package WebFlow.RemoteFile;

import WebFlow.*;
import WebFlow.event.*;

import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;

public class Client 
{
    public static void main(String args[])
    {
        configReader config;
	try
	{
	    System.out.println("Please wait, initializing ORB...");

            Properties props = System.getProperties();
            props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
            props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
            System.setProperties(props);

            //
            // Create ORB and BOA
            //
            ORB orb = ORB.init(args, props);

	    String ref = getIORFromFile(args[0]);
	    boolean flag = true;

	    org.omg.CORBA.Object  obj = orb.string_to_object(ref);
	    if(obj == null)
		throw new RuntimeException();
	    System.out.println(ref);
	    System.out.println(obj);

	    WebFlowContext master = WebFlowContextHelper.narrow(obj);
	    System.out.println("master = " + master);
	    if(master == null)
		throw new RuntimeException();
	    System.out.println("2");
	    System.out.println("Webflow server is connected");

	    obj = master.addNewModule("RemoteFile");	    
	    
	    if(obj == null)
	      throw new Exception("Failed to get module reference");
	    
	    RemoteFile file = RemoteFileHelper.narrow(obj);
	    System.out.println("RemoteFile module reference sucessfully resovled");
	    
	    file.mkdir("test");
	    file.mkdir("test_dir_2");
	    file.rename("test_dir_2", "test_dir_second");
	    file.copy("master.conf", "test/master.rrr");
	    file.copy("master.conf", "test");
	    file.copy("test_for_delete", "test");
	   

	    obj = master.addNewModule("MoveFile");	    
	    
	    if(obj == null)
	      throw new Exception("Failed to get module reference");
	    
	    MoveFile mfile = MoveFileHelper.narrow(obj);
	    System.out.println("MoveFile module reference sucessfully resovled");
	    mfile.Init(file);
	    mfile.FileSend("/npac/home/webflow/WEBFLOW/BeanContext_2.2.2/remotefile/test/test2.txt", "/npac/home/webflow/WEBFLOW/BeanContext_2.2.2/remotefile/test/test.txt");
	} catch(Exception ex) {
	  System.out.println("Exception was thrown: " + ex.getMessage());
	  System.out.println(ex);
	}
    }
  
    
    static public String getIORFromFile(String file_name)
    {
	String ref = null;
	try
	    {
		String refFile = file_name;
		java.io.BufferedReader in =
		    new java.io.BufferedReader(new FileReader(refFile));
		ref = in.readLine();
	    }
	catch(java.io.IOException ex)
	    {
		System.err.println("Can't read from " +
				   ex.getMessage() + "'");
		System.exit(1);
	    }
	return ref;
    }

    static public String getIORFromURL(String aURL) 
    {
	System.out.println("getIORFromFile is called for: " + aURL);
	String IOR = "";
	String thisLine=null;
	try {
	    URL url = new URL(aURL); //create URL java object
	    BufferedReader theHTML = new BufferedReader(new InputStreamReader(url.openStream()));
	    while ((thisLine = theHTML.readLine()) != null)
		IOR += thisLine;
	}
	catch (MalformedURLException e) {
	    System.out.println("GlobalConfig.getIORFromURL: " + aURL + " is not a parseable URL");
	    System.out.println("GlobalConfig.getIORFromURL: " + e);
	}
	catch (Exception e) {
	    System.out.println("GlobalConfig.getIORFromURL: " + e);
	}
	return IOR;
    }
}





