/*
	A	basic	extension	of the java.applet.Applet	class
 */

import java.awt.*;
import java.applet.*;

import org.omg.CORBA.*;
import java.io.*;
import WebFlow.RemoteFile.*;
//import javax.swing.*;

// To	compile, add java40.jar	to the class path.
import netscape.security.PrivilegeManager;

public class AppletFT	extends	Applet implements Runnable
{
	public boolean isStandalone	=	false;
	private Label progressBar;	
	private Label lsource, ldest;
	private Button btn;
	UpdateThread update_thread;
	private Thread thread, main_thread = new Thread(this);
	public String	args[];
	
	private	FileTransfer file_transfer;
	
	public void	init()
	{	       
	    if(!isStandalone)
		PrivilegeManager.enablePrivilege("UniversalFileAccess");
	    try	{
		//Create the demo's UI.
		setLayout(new GridLayout(3, 1));
		progressBar = new Label();
		ldest = new Label("Destination: " + getDest());
		lsource = new Label("Source: " + getSource());
		update_thread = new UpdateThread(progressBar);
		thread = new Thread(update_thread);
		add(lsource);
		add(ldest);
		add(progressBar);
	    }	catch(Exception	ex)	{
		error(ex.getMessage());
	    }		 
	}
	
	public void start()
	{ 
	  status("before starting thread");
	  main_thread.start();
	  status("after starting thread");
	  try {

  	} catch(Exception e) {
  	  error(e.getMessage());
  	}
  }
	
    void CORBAinit() throws	Exception
    {
	if(!isStandalone)
	    PrivilegeManager.enablePrivilege("UniversalFileAccess");
	java.util.Properties props = new java.util.Properties();
	ORB orb;
	if(isStandalone)
	    orb = ORB.init(args, props);
	else orb = ORB.init(this, props);
	if(orb == null)
	    error("ORB connecting	error");
	else
	    status("ORB	is created successfully");
	String ft_ref =	getFTIOR();		
	String source =	getSource(), dest = getDest();
	String action = getAction();
	status("Action is: " + action + ", source=" + source + ", dest=" + dest);
	try	{
	    if(action == null) throw new Exception("Action is not specified");
	    status("creating FileTransfer object...");
	    /*
	      org.omg.CORBA.Object obj = orb.string_to_object(ft_ref);
	      status("reference is converted to object...");
	      if(obj == null)
	      status("object is null!!!!");
	      RemoteFile rfile = RemoteFileHelper.narrow(obj);
	      if(rfile == null)
	      status("remote file is null!!!");
	    */
	    file_transfer = new	FileTransfer(orb, ft_ref, update_thread);
	    status("I am ready to copy file...");
	    if(action.equals("upload"))
		file_transfer.FileSend(source, dest);
	    else if(action.equals("download"))
		file_transfer.FileReceive(dest, source);
	    else throw new Exception("Unknown action name");
	    status("Transfer has been completed.");
	    
	}
	catch(Exception	ex)	{
	    error(ex.getMessage());
	}
    }
    
	String getSource()
	{
		if(!isStandalone)
			return getParameter("source");
		return "upload/image4.jpg";
	}
	
	String getDest()
	{
		if(!isStandalone)
			return getParameter("dest");		
		return "download/image4.jpg";
	}
	
	String getAction()
	{
	  if(!isStandalone)
  	  return getParameter("action");
  	return "upload";
	}
	
    String getFTIOR()
    {
	String ref = null;
	if(isStandalone) {
	    try	{
		String refFile = "File.ref";
		BufferedReader in	=	new	BufferedReader(new FileReader(refFile));
		ref	=	in.readLine();
	    }	catch(java.io.IOException	ex)	{
		System.err.println("Can't	read from	'" + ex.getMessage() + "'");
		return ref;
	    }		 
		}
	else {
	    java.net.URL url = null;
	    try	{
		String url_name	=	this.getParameter("ft_url");
		status("reading	IOR	from URL:	"	+	url_name);
		url	=	new	java.net.URL(url_name);
		InputStream	istream;				
		istream	=	url.openStream();
		BufferedReader in	=	new	BufferedReader(new InputStreamReader(istream));
		ref	=	in.readLine();
		istream.close();
	    }
	    catch(IOException	e) {
		error("Can't open	URL: " + url);
		return ref;
	    }
	}
	status("I've got IOR of	file transfer	object");
	return ref;
    }
	
	void status(String msg)
	{
		System.out.println(msg);
	}

	void error(String	msg)
	{
		System.err.println(msg);
	}
	
	public static	void main(String[] args) {
		AppletFT applet	=	new	AppletFT();
		applet.args	=	args;
		applet.isStandalone	=	true;
		Frame	frame	=	new	Frame();
		frame.setTitle("Applet Frame");
		frame.add(applet,	BorderLayout.CENTER);
		applet.init();
		applet.start();
		frame.setSize(426, 20);
		Dimension	d	=	Toolkit.getDefaultToolkit().getScreenSize();
		frame.setLocation((d.width - frame.getSize().width)	/	2, (d.height - frame.getSize().height) / 2);
		System.out.println("about to show applet");
		frame.setVisible(true);
	}
	
	public void run() {
	  try {
	    thread.start();
  		CORBAinit();      	    	  	    
	  }
	  catch(Exception e){
	    status(e.getMessage());
	  }
	}
}


class UpdateThread implements Runnable, FTcallback
{
  private Label label;
  private int progress;
  
  public UpdateThread(Label alabel)
  {
    label = alabel;
  }
  
  public void run()
  {
	  try {
	    while(progress != 100) {
	      Thread.sleep(1000);	      
	      label.setText("Progress: " + progress + " %");
	    }
	  }
	  catch(Exception e){
	    System.out.println(e.getMessage());
	  }  
	}
	
	public void transfered(int bytes)
	{
	  progress = bytes;
	}
}
